//show and hide events
(function ($) {
    $.each(['show', 'hide'], function (i, ev) {
        var el = $.fn[ev];
        $.fn[ev] = function () {
            this.trigger(ev);
            return el.apply(this, arguments);
        };
    });
})(jQuery);


(function ($) {
    $.event.special.destroyed = {
        remove: function (o) {
            if (o.handler) {
                o.handler()
            }
        }
    }
})(jQuery)


var keepUpdate = {};
var isLogged = false;

toggleMenu();

$(".linkcheck").on("click", checkHandle);
$(".checkall").on("click", checkAll);
$(".generate").on("click", generate);
$(".menuItem").on("click", selectMenu);
$("#linkgen").on("show", linkgenShow);
$("#download").on("show", downloadShow);
$("#torrentlist").on("show", torrentShow);
$("#filehost").on("show", filehostShow);
$("#account").on("show", accountShow);
$("#settings").on("show", settingsShow);
$("#newsfeed").on("show", newsShow);
$(".t2ip").on("mouseover", showTip);

function showTip() {
    var $tooltip = $('.eTip');
    var mPos = $(this).offset();
    if ($(this).attr("title") == "") {
        return false;
    }
    $tooltip.text($(this).attr("title"));
    if (mPos.top < 20) {
        $tooltip.css("top", mPos.top).css("left", mPos.left + $(this).width() + 15);
    } else {
        $tooltip.css("top", mPos.top - 20).css("left", mPos.left - 3);
    }
    $tooltip.show();
    $(this).on("mouseout", function () {
        if ($('.eTip').is(":visible")) {
            $('.eTip').hide();
        }
    });
    $(this).on("destroyed", function () {
        if ($('.eTip').is(":visible")) {
            $('.eTip').hide();
        }
    });
}
self.port.on("removeEle", function (div) {
    $(div).remove();
});
self.port.on("isLogged", function (state) {
    isLogged = state;
});
self.port.on("triggerEvent", function (info) {
    if (isLogged || info.div == ".menuItem .fa-user-secret") {
        $(info.div).trigger(info.event);
    }
});
self.port.on("hideLoader", function () {
    hideLoader();
});
function delHandle() {
    var linkid = $(this).parent().attr("id");
    self.port.emit("delete", linkid);
}

function getExtension(filepath) {
    filepath = filepath.toLowerCase();
    var fileinfo = filepath.substr((filepath.length - 3), 3);
    return fileinfo;
}


//link generation
$(".fetchtab").on("click", function () {
    self.port.emit("fetchtab");
});
$(".fetchclip").on("click", function () {
    self.port.emit("processClip");
});
self.port.on("updateBadge", function (count) {
    if (count > 0) {
        $(".badge").text(count);
        $(".badge").show();
    }
});
self.port.on("link", function (info) {
    $(".lngen").css("display","none");

    $(".checkall").show();
    var $newLi = $("<li class='ln linklist' id='" + info.id + "'><a target='_blank' href=\"" + info.link + "\">" + fixName(info.link, 46) + "</a></li>");
    $($newLi).bind('destroyed', function () {
        if ($(".linklist").length == 1) {
            $(".checkall").hide();
            $(".badge").hide();
            $(".lngen").css("display","block");
        }
    });
    $newLi.find("a").on("mouseover", function () {
        $(this).text(info.link);
        $(this).on("mouseout", function () {
            $(this).text(fixName(info.link, 46));
        });
    });
    var $checkBox = $("<i class=\"linkcheck fa fa-check-square-o\"></i>");
    var $delBtn = $("<i title='Delete' class=\"t2ip fa fa-trash-o pr mr\"></i>");
    $checkBox.click(checkHandle);
    $delBtn.click(delHandle);
    $newLi.prepend($checkBox);
    $newLi.append($delBtn);
    $("#pendingList").prepend($newLi);
    $(".t2ip").on("mouseover", showTip);
});
self.port.on("linkstatus", function (info) {
    var mydiv = "#" + info.id;
    $(mydiv + " .fa-spinner").removeClass("fa-spinner").removeClass("fa-spin").addClass("fa-square-o");
    $(mydiv).css("background-color", "rgba(237, 34, 0, 0.62)");
    $(mydiv).attr("title", info.error);
    if (!$(mydiv).hasClass("t2ip")) {
        $(mydiv).addClass("t2ip")
    }
    $(".t2ip").on("mouseover", showTip);
});
self.port.on("init", function (tab) {
    if (tab == "linkgen") {
        $("#pendingList").html("");
        self.port.emit("initPending");
    }
});
function linkgenShow() {
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-trash'></i><small> Clear</small></button>");
    $control.click(function () {
        $(".badge").hide();
        $(".checkall").hide();
        $(".lngen").css("display","block");
        $("#pendingList li").each(function () {
            self.port.emit("delete", $(this).attr("id"));
        });
    });
    $(".topNav").html($control);
}
function generate() {
    $(".linkcheck").each(function () {
        if ($(this).hasClass("fa-check-square-o")) {
            $(this).removeClass("fa-check-square-o").addClass('fa-spinner').addClass("fa-spin");

            $(this).click(function () {
                return false;
            });

            var linkInfo = {link: $(this).next().attr("href"), id: $(this).parent().attr("id")};
            self.port.emit("doGenerate", linkInfo);
        }
    });
}
function checkHandle() {
    if ($(this).hasClass("fa-check-square-o")) {
        $(this).removeClass("fa-check-square-o");
        $(this).addClass("fa-square-o");
    } else {
        $(this).addClass("fa-check-square-o");
        $(this).removeClass("fa-square-o");
    }
}
function checkAll() {
    if ($(this).text() == " Select All") {
        $(".linkcheck").each(function () {
            if ($(this).hasClass("fa-square-o")) {
                $(this).removeClass("fa-square-o");
                $(this).addClass("fa-check-square-o");
            }
        });
        $(this).html("<i class='fa fa-square-o'></i> Deselect All");
    } else {
        $(".linkcheck").each(function () {
            if ($(this).hasClass("fa-check-square-o")) {
                $(this).removeClass("fa-check-square-o");
                $(this).addClass("fa-square-o");
            }
        });
        $(this).html("<i class='fa fa-check-square-o'></i> Select All");
    }
}


//generated links

self.port.on("delfailed",function(info){
    self.port.emit("delete", info);
});

self.port.on("generatedLinks", function (info) {
    hideLoader();

    ///generate tab visibility
    if (!$("#download").is(':visible')) {
        selectMenuAlt($(".menuItem .fa-cloud-download").parent());
        initDSbtn();
    }
    $(".lndl").css("display","none");

    //

    var $newTr = $('<tr class="dllist" id="' + info.id + '"></tr>');

    $($newTr).bind('destroyed', function () {
        if ($(".dllist").length == 1) {
            $(".lndl").css("display","block");
        }
    });

    var $dllink = $('<td><a class="dlink" href="' + info.downloadlink + '" target="_blank">' + fixName(info.filename) + '</a></td>');
    var $actionMenu = $('<div class="action-menu"><a target="_blank" href="' + info.downloadlink + '"><button title="Download" class="t2ip menuItem btn-text" title="Download"><i class="fa fa-download"></i></button></a></div>');
    var $clipBtn = $('<button title="Copy to Clipboard" class="t2ip menuItem btn-text"><i class="fa fa-clipboard"></i></button>');
    var $reportBtn = $('<button title="Report" class="t2ip menuItem btn-text"><i class="fa fa-info-circle"></i></button>');
    var $watchNow = $('<button title="Watch Now" class="t2ip menuItem btn-text"><i class="fa fa-tv"></i></button>');
    var $delBtn = $('<button class="t2ip menuItem btn-text" title="Delete"><i class="fa fa-trash"></i></button>');
    $delBtn.click(function () {
        var $genBx = $(this).parent().parent().parent();
        var linkid = $genBx.attr("id");
        self.port.emit("delete", linkid);
    });
    var $regenBtn = $('<button class="t2ip menuItem btn-text" title="Regenerate"><i class="fa fa-random"></i></button>');
    $regenBtn.on("click",function () {
        self.port.emit("reGenerate", {link: info.link, id: info.id});
    });
    $dllink.find("a").on("mouseover", function () {
        $(this).text(info.filename);
        $(this).on("mouseout", function () {
            $(this).text(fixName(info.filename));
        });
    });
    $reportBtn.on("click", function () {
        if ($actionMenu.find(".reportSec").length) {
            $actionMenu.find(".reportSec").remove();
            return false;
        }
        var $reportMsg = $('<div class="reportSec" style="margin-top:5px;"></div>');
        var $reportTxt = $('<textarea placeholder="Message"></textarea>');
        var $reportSubmitBtn = $('<button class="menuItem btn-text">Send <i class="fa fa-send-o"></i></button>');

        $reportSubmitBtn.on("click", function () {
            self.port.emit("reportlink", {link: info.link, genlink: info.downloadlink, msg: $reportTxt.val()});
            $reportMsg.remove();
        });
        $reportMsg.append($reportTxt);
        $reportMsg.append("<br>");
        $reportMsg.append($reportSubmitBtn);
        $actionMenu.append($reportMsg);
    });


    $clipBtn.on("click", function () {
        self.port.emit("clipboard", {job: "add", text: info.downloadlink});
    });

    var myExt = getExtension(info.filename);
    if (myExt == "mp4" || myExt == "mkv" || myExt == "avi" || myExt == "mov") {
        $watchNow.on("click", function () {
            self.port.emit("stream", {link: info.downloadlink, type: myExt});
        });
        $actionMenu.append($watchNow);
    }


    $actionMenu.append($clipBtn);
    $actionMenu.append($regenBtn);
    $actionMenu.append($reportBtn);
    $actionMenu.append($delBtn);
    $dllink.append($actionMenu);
    $newTr.html($dllink);

    $("#generatedlinks").prepend($newTr);
    $(".t2ip").on("mouseover", showTip);
});
function downloadShow() {
    $("#generatedlinks").html("");
    ///if($("#generatedlinks").html() == ""){
    self.port.emit("getGenerated");
    //}
    initDSbtn();
}
function initDSbtn() {
    var $control = $("<button title='Clear All' class='t2ip btn-nav controlBtn'><i class='fa fa-trash'> <small></small></i></button>");
    $control.click(function () {
        $("#generatedlinks tr").each(function () {
            $(".lndl").css("display","block");
            self.port.emit("delete", $(this).attr("id"));
        });
    });
    var $copyAll = $("<button title='Copy All' class='t2ip btn-nav controlBtn'><i class='fa fa-clipboard'> <small></small></i></button>");
    $copyAll.click(function () {

        self.port.emit("clipboard", {job: "clear"});
        $(".dlink").each(function () {
            self.port.emit("clipboard", {job: "append", text: $(this).attr("href")});
        });
    });
    $(".topNav").html($control);
    $(".topNav").append($copyAll);
}

//torrents
var lastBrowsedTorrent = false;
function addRemoveClass(div, aC, rC) {
    if ($(div).hasClass(rC)) {
        $(div).css("border-left", "0");
        $(div).removeClass(rC);
    }
    if (!$(div).hasClass(aC)) {
        $(div).addClass(aC);
    }
}
function torrentColor(div, type) {
    var $aHref = div.find("a");

    switch (type) {
        case "done":
            //div.css("background","none");
            $aHref.css('font-weight', 'bold');
            break;
        case "processing":
            $aHref.css('font-weight', '400');
            break;
        case "pending":
            //div.css('cssText', 'border-left: 4px solid rgba(197, 81, 16, 0.87) !important');
            $aHref.css('font-weight', 'normal');
            break;
    }
}
self.port.on("torrentFiles", function (info) {
    hideLoader();
    $(".lntorrent").css("display","none");

    var currentDay = new Date();
    var torrentDay = new Date(info.time * 1000);
    var torrentAge = Math.round((currentDay - torrentDay) / (1000 * 60 * 60 * 24));


    var $newTr = $('<tr></tr>');
    var $dllink = $('<td class="tlist" id="' + info.id + '"></td>');
    $($dllink).bind('destroyed', function () {
        if ($(".tlist").length == 1) {
            $(".lntorrent").css("display","block");
        }
    });
    var linkCls = "dlink";
    if (info.status == "zip") {
        linkCls = "dcomp";
    }
    //
    //white-space:nowrap;word-wrap: break-word;
    var $file = $('<div><a class="' + linkCls + ' ln" style="float:left" data-name="' + info.name + '" href="https://linksnappy.com/myaccount/torrents/files/' + info.id + '" target="_blank"><i class="fa fa-clone"></i> ' + fixName(info.name) + '</a></div><div class="clearfix"></div>');

    $dllink.append($file);


    $file.parent().on("mouseover", function () {
        var $aHref = $file.find("a");
        var $faIcon = $aHref.find("i");
        $aHref.html(" " + info.name);
        $aHref.prepend($faIcon);
        $file.parent().on("mouseout", function () {
            $aHref.html(" " + fixName(info.name));
            $aHref.prepend($faIcon);
        });
    });

    $file.click(function () {
        var $aHref = $(this).find("a");
        if ($aHref.hasClass("dcomp")) {
            showLoader("Loading Folder...");
            $("#torrentStats").html("");
            lastBrowsedTorrent = "/myaccount/torrents/files/" + info.id;
            self.port.emit("browseTorrent", {link: "/myaccount/torrents/files/" + info.id});
        }
        return false;
    });

    var $actionMenu = $('<div class="action-menu"></div>');
    var $progressBar = $('<div class="torrentProgress"></div>');
    $dllink.append($progressBar);
    var $torrentTools = $('<div class="pr"></div>');
    if (info.downloading == 1) {
        torrentColor($dllink, "processing");
        clearInterval(keepUpdate[info.id]);
        keepUpdate[info.id] = setInterval(function () {
            self.port.emit("getTorrentStats", info.id);
        }, 1000);
        var $statBtn = $('<button class="menuItem btn-text" title="Stats"><i class="fa fa-dashboard"></i><span>In Progress</span></button>');
        $torrentTools.append($statBtn);

    }
    var $delBtn = $('<button class="menuItem btn-text" title="Delete"><i class="fa fa-trash"></i></button>');
    $delBtn.click(function () {
        $(this).replaceWith('<button class="menuItem btn-text" title="Download"><i class="fa fa-trash"></i>Processing...</button>');
        self.port.emit("delTorrent", info.id);
    });
    if (info.status == "start") {
        torrentColor($dllink, "pending");
        var $startBtn = $('<button class="menuItem btn-text" title="Download"><i class="fa fa-download"></i>Start</button>');
        $startBtn.click(function () {
            $(this).replaceWith('<button class="menuItem btn-text" title="Download"><i class="fa fa-download"></i>Processing...</button>');
            self.port.emit("startTorrent", info.id);
        });
        $torrentTools.append($startBtn);
    }
    if (info.status == "zip") {
        torrentColor($dllink, "done");
        var $zipBtn = $('<button class="menuItem btn-text" title="Download"><i class="fa fa-file-zip-o"></i>Zip</button>');
        $zipBtn.click(function () {
            $(this).replaceWith('<button class="menuItem btn-text" title="Download"><i class="fa fa-file-zip-o"></i>Processing...</button>');
            self.port.emit("zipTorrent", info.id);
        });
        $torrentTools.append($zipBtn);
    }
    var $sizeTxt = $('<span class="sizeTxt">' + info.size + '</span>');
    $actionMenu.append($sizeTxt);
    $torrentTools.append($delBtn);
    $actionMenu.append($torrentTools);
    $dllink.append($actionMenu);
    $newTr.html($dllink);

    $("#torrentStats").append($newTr);

    if (info.status == "start" && torrentAge <= 2) {
        $startBtn.replaceWith('<button class="btn-nav" title="Download"><i class="fa fa-download"></i> Processing...</button>');
        self.port.emit("startTorrent", info.id);
    }
});
self.port.on("returnStartBtn", function (tid) {
    //alert(tid);
    $("#" + tid + " .actionMenu .fa-download").replaceWith('<button class="btn-nav" title="Download"><i class="fa fa-download"></i>Start</button>').on("click", function () {
        $(this).replaceWith('<button class="btn-nav" title="Download"><i class="fa fa-file-zip-o"></i>Processing...</button>');
        self.port.emit("startTorrent", tid);
    });
});
self.port.on("torrentStatus", function (info) {

    var progress = info.parcent;
    if (progress == "0") {
        progress = 5;
    }
    //background: ;

    //$("#"+info.id+" .torrentProgress").css("width",info.parcent + "%");
    if (info.status == "IN_PROCESS") {
        $("#" + info.id + "").css("background", "-moz-linear-gradient(left, #d5eaab " + info.parcent + "%, #F7F9FA " + info.parcent + "%)");
    }
    if (info.status == "QUEUE") {
        clearInterval(keepUpdate[info.id]);
        keepUpdate[info.id] = false;
        var $startBtn = $('<button class="menuItem btn-text" title="Download"><i class="fa fa-download"></i>Start</button>');
        $startBtn.click(function () {
            $(this).replaceWith('<button class="menuItem btn-text" title="Download"><i class="fa fa-download"></i>Processing...</button>');
            self.port.emit("startTorrent", info.id);
        });
        $("#" + info.id + " .action-menu .fa-dashboard").parent().replaceWith($startBtn);
        return true;
    }
    if (info.parcent == "100") {
        //$("#"+info.id+" .torrentProgress").css("width","0");
        torrentColor($("#" + info.id), "done");
        clearInterval(keepUpdate[info.id]);
        keepUpdate[info.id] = false;
        var $zipBtn = $('<button class="menuItem btn-text" title="Download"><i class="fa fa-file-zip-o"></i>Zip</button>');
        $zipBtn.click(function () {
            $(this).replaceWith('<button class="menuItem btn-text" title="Download"><i class="fa fa-file-zip-o"></i>Processing...</button>');
            self.port.emit("zipTorrent", info.id);
        });
        $("#" + info.id + " .action-menu .fa-dashboard").parent().replaceWith($zipBtn);
        $("#" + info.id + " .dlink").removeClass("dlink").addClass("dcomp");


    } else {
        $("#" + info.id + " .action-menu .fa-dashboard").next().text(info.parcent + "% " + info.downloadRate);
    }
});
self.port.on("torrentStart", function (info) {
    clearInterval(keepUpdate[info]);
    keepUpdate[info] = setInterval(function () {
        self.port.emit("getTorrentStats", info);
    }, 1000);
    var $statBtn = $('<button class="menuItem btn-text" title="Stats"><i class="fa fa-dashboard"></i><span>In Progress</span></button>');
    $statBtn.click(function () {
        return false;
    });
    torrentColor($("#" + info), "processing");
    $("#" + info + " .action-menu .fa-download").parent().replaceWith($statBtn);

});
self.port.on("zipStatus", function (info) {
    var $dlBtn = $('<a href="' + info.link + '" target="_blank"><button class="menuItem btn-text" title="Download"><i class="fa fa-cloud-download"></i> Download</button></a>');
    //$dlBtn.click(function(){return false;});
    $("#" + info.id + " .action-menu .fa-file-zip-o").parent().replaceWith($dlBtn);
});
self.port.on("torrentUsage", function (info) {
    $(".torrentUsage").text(info);
});
self.port.on("setTorrentBack", function (info) {
    $(".topNav").html('');
    var $rootControl = $("<button title='Torrent View' class='t2ip btn-nav controlBtn'><i class='fa fa-home'></i></button>");
    $rootControl.click(function () {
        lastBrowsedTorrent = false;
        $(".menuItem .fa-magnet").trigger("click");
    });
    $(".topNav").append($rootControl);
    if (info) {
        var $control = $("<button title='Go Back' class='t2ip btn-nav controlBtn'><i class='fa fa-mail-reply-all'></i></button>");
        $control.click(function () {
            showLoader("Loading Previous Folder...");
            $("#torrentStats").html("");
            lastBrowsedTorrent = info;
            self.port.emit("browseTorrent", {link: info});
        });
        $(".topNav").append($control);
    }

    $(".t2ip").on("mouseover", showTip);
});
self.port.on("torrentTxtShow",function(){
    $(".lntorrent").css("display","block");
});
self.port.on("torrentBrowse", function (info) {
    hideLoader();
    $(".lntorrent").css("display","none");

    var fid = info.id;
    var $newTr = $('<tr></tr>');
    var $dllink = $('<td id="' + info.id + '"></td>');

    var $file = $('<div><a class="dlink ln" style="float:left;" data-name="' + info.name + '" href="https://linksnappy.com' + info.link + '" target="_blank">' + fixName(info.name) + '</a></div><div class="clearfix"></div>');
    var $aHref = $file.find("a");
    $dllink.append($file);

    var $actionMenu = $('<div class="action-menu"></div>');
    var $torrentTool = $('<div class="pr"></div>');
    if (info.isFolder == 1) {
        $file.find("a").prepend('<i class="fa fa-clone"></i> ');
        $file.click(function () {
            showLoader("Loading Folder...");
            $("#torrentStats").html("");
            lastBrowsedTorrent = info.link;
            self.port.emit("browseTorrent", {link: info.link});
            return false;
        });
    } else {
        var $clipBtn = $('<button title="Copy to Clipboard" class="t2ip menuItem btn-text"><i class="fa fa-clipboard"></i></button>');
        $clipBtn.on("click", function () {
            self.port.emit("clipboard", {job: "add", text: "https://linksnappy.com" + info.link});
        });
        var $downBtn = $('<a target="_blank" href="https://linksnappy.com' + info.link + '"><button title="Download" class="t2ip menuItem btn-text" title="Download"><i class="fa fa-download"></i></button></a>');

        var $watchNow = $('<button title="Watch Now" class="t2ip menuItem btn-text"><i class="fa fa-tv"></i></button>');
        $torrentTool.append($downBtn);

        var myExt = getExtension(info.name);
        if (myExt == "mp4" || myExt == "mkv" || myExt == "avi" || myExt == "mov") {
            $watchNow.on("click", function () {
                self.port.emit("stream", {link: "https://linksnappy.com" + info.link, type: myExt, torrent: true});
            });
            $torrentTool.append($watchNow);
        }

        switch (myExt) {
            case "mkv":
            case "avi":
            case "mov":
            case "mp4":
                $aHref.prepend('<i class="fa fa-file-video-o"></i> ');
                break;
            case "mp3":
            case "ogg":
            case "flac":
            case "m4a":
                $aHref.prepend('<i class="fa fa-file-audio-o"></i> ');
                break;
            case "zip":
            case "rar":
                $aHref.prepend('<i class="fa fa-file-archive-o"></i> ');
                break;
            case "jpeg":
            case "jpg":
            case "png":
            case "gif":
            case "bmp":
                $aHref.prepend('<i class="fa fa-file-photo-o"></i> ');
                break;
            case "txt":
            case "nfo":
                $aHref.prepend('<i class="fa fa-file-text-o"></i> ');
                break;
            case "pdf":
                $aHref.prepend('<i class="fa fa-file-pdf-o"></i> ');
                break;
            default:
                $aHref.prepend('<i class="fa fa-file-o"></i> ');
        }

        $torrentTool.append($clipBtn);
        var $sizeTxt = $('<span class="sizeTxt">' + info.size + '</span>');
        $actionMenu.append($sizeTxt);
        $actionMenu.append($torrentTool);

    }


    $file.parent().on("mouseover", function () {
        var $faIcon = $aHref.find("i");
        $aHref.text(" " + info.name);
        $aHref.prepend($faIcon);
        $file.parent().on("mouseout", function () {
            $aHref.text(" " + fixName(info.name));
            $aHref.prepend($faIcon);
        });
    });

    $dllink.append($actionMenu);
    $newTr.html($dllink);

    $("#torrentStats").append($newTr);
    $(".t2ip").on("mouseover", showTip);
});

function searchTorrent() {
    var searchTxt = $(this).val().toLowerCase();
    $("#torrentStats > tr > td > div > a").each(function () {
        var filename = $(this).data("name").toLowerCase();
        if (searchTxt == "") {
            $(this).parent().parent().css("display", "block");
            return 1;
        }
        if (filename.indexOf(searchTxt) != -1) {
            $(this).parent().parent().css("display", "block");
        } else {
            $(this).parent().parent().css("display", "none");
        }
    });
}
$("#torrentlist").on("hide", function () {
    $("#searchTorrent").off("change", searchTorrent);
    $("#torrentStats tr td").each(function () {
        var myid = $(this).attr("id");
        clearInterval(keepUpdate[myid]);
    });
});
function torrentShow() {
    showLoader("Torrents");
    $("#torrentStats").html("");
    $("#searchTorrent").on("change", searchTorrent);
    if (lastBrowsedTorrent) {
        self.port.emit("browseTorrent", {link: lastBrowsedTorrent});
    } else {
        self.port.emit("torrentShow");
    }
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-database'></i> <small><span class='torrentUsage'>Torrents</span></small></button>");
    $control.click(function () {
        self.port.emit("openlink", "https://linksnappy.com/myaccount/torrents");
    });
    $(".topNav").html($control);
}


//filehost
self.port.on("filehostStatus", function (filehost) {
    hideLoader();
    $("#filehostList").html("");
    var mainhost = ["rapidgator.net",
        "uploaded.net",
        "depfile.com",
        "filefactory.com",
        "keep2share.cc",
        "1fichier.com",
        "share-online.biz",
        "turbobit.net",
        "bigfile.to",
        "uptobox.com",
        "easybytez.com",
        "alfafile.net",
        "uploadrocket.net",
        "oboom.com",
        "filesmonster.com",
        "gigapeta.com",
        "extmatrix.com",
        "rapidu.net",
        "hugefiles.net"];


    for (var i = 0; i < mainhost.length; i++) {
        fhostSts(mainhost[i], filehost[mainhost[i]]);
        delete filehost[mainhost[i]];
    }
    jQuery.each(filehost, function (host, stats) {
        fhostSts(host, stats);
    });

});

function fhostSts(host, stats) {
    var status = "";
    if (stats.Quota == "unlimited") {
        status = "Unlimited";
    } else {
        if (stats.canDownload == 1) {
            var currentUsage = stats.Quota - stats.Usage;

            status = formatBytes(currentUsage, 0) + " Left";
        } else {
            if (stat.canDownload == "undefined") {
                status = formatBytes(stats.Quota, 0);
            } else {
                status = "Limit Reached";
            }

        }
    }
    var isDead = "";
    if (stats.Status == "0") {
        isDead = 'border-left: 4px solid #c50c15;';
        status = "Down"
    }
    var $meHost = $('<tr><td style="' + isDead + '"><img src="https://linksnappy.com/templates/images/filehosts/small/' + host + '.png"> <a target="_blank" href="http://' + host + '">' + host + '</a></td><td>' + status + '</td></tr>');
    $("#filehostList").append($meHost);
}

function filehostShow() {
    showLoader("Filehost Status");
    self.port.emit("getFilehost");

    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-signal'></i> <small>Filehost Status</small></button>");
    $(".topNav").html($control);
}

//acount
function toggleAccDiv(div) {
    $(".accDiv").each(function () {
        $(this).css("display", "none");
    });
    $(div).css("display", "block");
}
$("#accLoginBtn").on("click", function () {
    showLoader("Logging in...");
    $(".accLogin").css("display", "none");
    var username = $("#username").val();
    var password = $("#password").val();
    self.port.emit("doLogin", {username: username, password: password});
});
$("#accRegister").on("click", function () {
    $(".accLogin").css("display", "none");
    showLoader("Registering...");
    var email = $("#accEmail").val();
    self.port.emit("doRegister", email);
});

self.port.on("showLogin", function () {
    hideLoader();
    toggleAccDiv(".accLogin");
    $(".accDetails").html("");
    isLogged = false;
    toggleMenu();

    $(".logo").css("left","240px");
    $("#onlyElite").css("display","none");

    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-user-secret'></i> <small>Account Login</small></button>");
    $control.click(function () {
        return false;
    });
    $(".topNav").html($control);
});
self.port.on("twofactor", function (link) {
    hideLoader();
    toggleAccDiv(".twoFactor");
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-user-secret'></i> <small>2-Factor Verification</small></button>");
    $control.click(function () {
        return false;
    });
    $(".topNav").html($control);
    var validCode = link.split("/");
    $("#twoFactorBtn").on("click", function () {
        if ($("#twofpin").val() != "") {
            showLoader("Validating...");
            self.port.emit("twoFactor", {reqCode: validCode[2], twofpin: $("#twofpin").val()})
        }
    });
    //alert(validCode[2]);
});
self.port.on("getAccount", function (info) {
    hideLoader();
    toggleAccDiv(".accDetails");
    isLogged = true;
    toggleMenu();

    var d = new Date();
    var expiry = "";
    if (info.expire == "lifetime") {
        expiry = "Lifetime";
    } else {
        if (info.expire == "expired") {
            expiry = "Free";
        } else {
            var eTime = new Date(info.expire * 1000);
            expiry = eTime.toDateString();
            var daysleft = Math.round((eTime - d) / (1000 * 60 * 60 * 24));
        }
    }
    if (info.accountType != "elite") {
        expiry = "Free";
    }else{
        $(".logo").css("left","200px");
        $("#onlyElite").css("display","block");
    }
    var html = '<p><strong>Username: </strong>' + info.username + ' </p>' +
        // '<p><strong>Account Type: </strong>'+info.accountType+' </p>' +
        '<p><strong>Elite Membership till: </strong>' + expiry + '</p>' +
        '<p><strong>Daily traffic left: </strong>' + formatBytes(info.trafficleft, 1) + ' (<a target="_blank" href="https://linksnappy.com/tos#fairusage">Lift limits</a>)</p>';

    var $btnLogout = $('<button title="Logout" class="t2ip btn-nav btn-text btn-prime pr"><i class="fa fa-sign-out"></i></button>');
    $(".accDetails").html($btnLogout);
    $(".accDetails").append(html);
    $(".t2ip").on("mouseover", showTip);

    if (info.accountType == "elite" && expiry != "Lifetime" && daysleft < 8) {
        var $btnPrebuy = $('<br><button class="btn-nav btn-text" style="margin-right: 10px; color: white; background-color: rgba(236, 37, 31, 0.8);">Renew Premium <i class="fa fa-diamond"></i></button>');
        $btnPrebuy.on("click", function () {
            self.port.emit("openlink", "https://linksnappy.com/myaccount/extend");
        });
        $(".accDetails").append($btnPrebuy);
    } else if (expiry == "Free") {
        var $btnPrebuy = $('<br><button class="btn-nav btn-text" style="margin-right: 10px; color: white; background-color: rgba(236, 37, 31, 0.8);">Buy Premium <i class="fa fa-diamond"></i></button>');
        $btnPrebuy.on("click", function () {
            self.port.emit("openlink", "https://linksnappy.com/myaccount/extend");
        });
        $(".accDetails").append($btnPrebuy);
    }

    var $btnHelpdesk = $('<button class="btn-nav btn-text" style="margin-right: 10px; color: white; background-color: rgb(23, 138, 121);">Helpdesk <i class="fa fa-users"></i></button>');
    $btnLogout.click(function () {
        showLoader("Logging out...");
        isLogged = false;
        toggleMenu();
        self.port.emit("doLogout");
    });
    $btnHelpdesk.on("click", function () {
        self.port.emit("openlink", "http://support.linksnappy.com/helpdesk");
    });


    $(".accDetails").append($btnHelpdesk);
});

function accountShow() {
    toggleAccDiv(".accDetails");
    showLoader("My Account");
    self.port.emit("grabAccount");
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-user-secret'></i> <small>My Account</small></button>");
    $control.click(function () {
        self.port.emit("openlink", "https://linksnappy.com/myaccount");
    });
    $(".topNav").html($control);

}
//


//settings
function settingsShow() {
    self.port.emit("getSettings");
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-cogs'></i> <small>Settings</small></button>");
    $(".topNav").html($control);
}
$(".setchk").on("click", settingsChk);

function settingsChk() {
    if ($(this).parent().hasClass("disabled")) return true;

    if ($(this).hasClass("fa-square-o")) {
        $(this).removeClass("fa-square-o").addClass("fa-check-square-o");
        self.port.emit("settings", {setting: $(this).attr("id"), value: 1});
    } else {
        $(this).removeClass("fa-check-square-o").addClass("fa-square-o");
        self.port.emit("settings", {setting: $(this).attr("id"), value: 0});
    }
}

$(".rebuildcache").on("click", function () {
    self.port.emit("rebuildregex");

});

$("#displaypanel").on("click", function () {
    var forcepanel = "#forcepanel";
    if ($(this).hasClass("fa-square-o")) {
        $(forcepanel).removeClass("setchk");
        $(forcepanel).parent().addClass("disabled");
        if ($(forcepanel).hasClass("fa-check-square-o")) {
            $(forcepanel).removeClass("fa-check-square-o").addClass("fa-square-o");
            self.port.emit("settings", {setting: "forcepanel", value: 0});
        }
    } else {
        $(forcepanel).parent().removeClass("disabled");
        $(forcepanel).addClass("setchk");
    }
});
self.port.on("getSettings", function (info) {
    if (info.value == 1) {
        $("#" + info.setting + ".fa").addClass("fa-check-square-o").removeClass("fa-square-o");
    } else {
        $("#" + info.setting + ".fa").addClass("fa-square-o").removeClass("fa-check-square-o");
    }
});

///news feed
function newsShow() {
    var $control = $("<button class='btn-nav controlBtn'><i class='fa fa-rss'></i> <small>News Feed</small></button>");
    $control.click(function () {
        self.port.emit("openlink", "https://www.facebook.com/LinkSnappyOfficial/");
    });
    $(".topNav").html($control);
}


function toggleMenu() {
    if (!isLogged) {
        toggleAccDiv(".accLogin");
        $(".menuItem").each(function () {
            if ($(this).data("menu") != "#account") {
                $(this).attr("disabled", "disabled");
            }
        });
    } else {
        $(".menuItem").each(function () {
            if ($(this).data("menu") != "#account") {
                $(this).removeAttr("disabled");
            }
        });
    }
}
//menu
function selectMenu() {
    var div = $(this).data("menu");
    $(".menuItem").each(function () {
        $($(this).data("menu")).hide();
        $(this).removeClass("mtActive");
    });
    if (div == "#linkgen") {
        $(".badge").hide();
        self.port.emit("badgeClear");
    }
    $(this).addClass("mtActive");
    $(div).show();
}

function selectMenuAlt(menu) {
    var div = $(menu).data("menu");
    $(".menuItem").each(function () {
        $($(this).data("menu")).hide();
        $(this).removeClass("mtActive");
    });
    $(menu).addClass("mtActive");
    $(div).css("display", "block");
}

function fixName(str, max) {
    if (!max) {
        max = 36;
    }
    var maxH = Math.round(max / 2);
    if (str.length > max) {
        var newStr = str.substr(0, maxH) + ".." + str.substr((str.length - maxH), maxH);
        return newStr;
    } else {
        return str;
    }
}

function formatBytes(bytes, decimals) {
    if (bytes == 0) return '0 Byte';
    var k = 1024; // or 1024 for binary
    var dm = decimals + 1 || 3;
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    var i = Math.floor(Math.log(bytes) / Math.log(k));
    return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function showLoader(text) {
    $("#loader").show();
    $("#loaderLabel").text(text);
}

function hideLoader() {
    $("#loader").hide();
}